#include <vector>

void ptr_compute(double *output1, double *output2,
                 double *output3, double *input1,
                 double *input2, int len)
{
   for (int i=0; i<len; ++i) {
      output1[i] = input1[i] * input2[i] ;
      output2[i] = input1[i] + input2[i] ;
      output3[i] = input1[i] - input2[i] ;
   }
}

template <class T> inline T&__restrict R(T& r) { return r; }

void stl_compute(std::vector<double> &output1, std::vector<double> &output2,
                 std::vector<double> &output3, std::vector<double> &input1,
                 std::vector<double> &input2, int len)
{  
   for (int i=0; i<len; ++i) {
     R(output1[i]) = R(input1[i]) * R(input2[i]);
     R(output2[i]) = R(input1[i]) + R(input2[i]);
     R(output3[i]) = R(input1[i]) - R(input2[i]);
   }
}

