#include <vector>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <iostream>

#define VECLEN 10000

typedef double __attribute__ ((aligned (16))) double_aligned;
extern void ptr_c_gr(double_aligned *output1, double_aligned *output2,
		     double_aligned *output3, double_aligned *input1,
		     double_aligned *input2, int len);

extern void ptr_c_br(double * __restrict__ __attribute__ ((aligned (16))) output1,
		     double * __restrict__ __attribute__ ((aligned (16))) output2,
		     double * __restrict__ __attribute__ ((aligned (16))) output3,
		     double * __restrict__ __attribute__ ((aligned (16))) input1,
		     double * __restrict__ __attribute__ ((aligned (16))) input2,
		     int len);

extern void ptr_c(double *output1, double *output2, double *output3, 
			double *input1, double *input2, int len);

extern void stl_c(std::vector<double> &output1,
		  std::vector<double> &output2,
		  std::vector<double> &output3,
		  std::vector<double> &input1,
		  std::vector<double> &input2, int len) ;

extern void stl_c_r(std::vector<double> &output1, std::vector<double> &output2,
		    std::vector<double> &output3, std::vector<double> &input1,
		    std::vector<double> &input2, int len);

int main(int argc, char *argv[])
{
   std::vector<double> stl_in1 ;
   std::vector<double> stl_in2 ;
   std::vector<double> stl_out1 ;
   std::vector<double> stl_out2 ;
   std::vector<double> stl_out3 ;

   void *void_in1 ;
   void *void_in2 ;
   void *void_out1 ;
   void *void_out2 ;
   void *void_out3 ;

   double *ptr_in1 ;
   double *ptr_in2 ;
   double *ptr_out1 ;
   double *ptr_out2 ;
   double *ptr_out3 ;

   stl_in1.resize(VECLEN,  0.0) ;
   stl_in2.resize(VECLEN,  0.0) ;
   stl_out1.resize(VECLEN, 0.0) ;
   stl_out2.resize(VECLEN, 0.0) ;
   stl_out3.resize(VECLEN, 0.0) ;

   posix_memalign(&void_in1,  16, VECLEN*sizeof(double)) ;
   posix_memalign(&void_in2,  16, VECLEN*sizeof(double)) ;
   posix_memalign(&void_out1, 16, VECLEN*sizeof(double)) ;
   posix_memalign(&void_out2, 16, VECLEN*sizeof(double)) ;
   posix_memalign(&void_out3, 16, VECLEN*sizeof(double)) ;

   ptr_in1 = static_cast<double *>(void_in1) ;
   ptr_in2 = static_cast<double *>(void_in2) ;
   ptr_out1 = static_cast<double *>(void_out1) ;
   ptr_out2 = static_cast<double *>(void_out2) ;
   ptr_out3 = static_cast<double *>(void_out3) ;

   memset(ptr_in1, 0,  VECLEN*sizeof(double)) ;
   memset(ptr_in2, 0,  VECLEN*sizeof(double)) ;
   memset(ptr_out1, 0, VECLEN*sizeof(double)) ;
   memset(ptr_out2, 0, VECLEN*sizeof(double)) ;
   memset(ptr_out3, 0, VECLEN*sizeof(double)) ;

   //start time
   clock_t t0 = clock();

   for (int i=0; i< 100000; i++) 
	   stl_c(stl_out1, stl_out2, stl_out3, stl_in1, stl_in2, VECLEN) ;

   clock_t t1 = clock();
   std::cout << "STL time is " << (t1 - t0) << "\n";

   t0=clock();
   for (int i=0; i< 100000; i++) 
	   stl_c_r(stl_out1, stl_out2, stl_out3, stl_in1, stl_in2, VECLEN) ;

   t1 = clock();
   std::cout << "STL restrict time is " << (t1 - t0) << "\n";
   t0=clock();

   for (int i=0; i< 100000; i++) {
	   ptr_c(ptr_out1, ptr_out2, ptr_out3, ptr_in1, ptr_in2, VECLEN) ;
   }
   t1 = clock();
   std::cout << "PTR (no restrict) time is " << (t1 - t0) << "\n";
   t0=clock();

   for (int i=0; i< 100000; i++) {
	   ptr_c_br(ptr_out1, ptr_out2, ptr_out3, ptr_in1, ptr_in2, VECLEN) ;
   }
   t1 = clock();
   std::cout << "PTR wrong restrict time is " << (t1 - t0) << "\n";

   t0=clock();

   for (int i=0; i< 100000; i++) {
	   ptr_c_gr(ptr_out1, ptr_out2, ptr_out3, ptr_in1, ptr_in2, VECLEN) ;
   }
   t1 = clock();
   std::cout << "PTR restrict time is " << (t1 - t0) << "\n";

   return 0 ;
}
